C
C--------------------------------------------------------------------
C     MULTIPLIIES THE UNIT CELL ( SINGLE OR 2 X 2 )
C--------------------------------------------------------------------
C
      SUBROUTINE UCMUL(mpix,nmx,nmy,lx,ly,D,imapuc)
C
      IMPLICIT none
      integer mpix,nmx,nmy,lx,ly,i,j,imapuc
      real*8 D(2*MPIX+1,2*MPIX+1),wert
      logical CR,error
C
C 2000 FORMAT(BN,I3)
 3010 FORMAT(' Select the number of unit cells.',
     $       '   0: single, 1: 2 x 2  [default=',i2,'] ',$)
C
10    WRITE(*,3010) imapuc
      CALL abfrage(wert,i,CR,error)
      if (error) goto 10
      if (.not.CR) then
         if (i.gt.1 .or. i.lt.0) then
           print *,'wrong input: has to be 0 or 1'
           goto 10
        else 
          imapuc=i
        endif
      endif

      IF (imapuc.eq.0) THEN
         lx=nmx
         ly=nmy
      ELSE
         DO 120 i=1,nmx
         DO 120 j=1,nmy
            D(i+nmx,j    )=D(i,j)
            D(i    ,j+nmy)=D(i,j)
            D(i+nmx,j+nmy)=D(i,j)
  120    CONTINUE
         lx=2*nmx
         ly=2*nmy
      END IF
C
      RETURN
      END
C
C
