C--------------------------------------------------------------------
C     CALCULATE STRUCTURE FACTORS. ( TYPE-F ) from asym. unit density
C--------------------------------------------------------------------
C
      SUBROUTINE CSTRCF(masym,nasym,RDEN,RMIC
     $                 ,RMIS
     $                 ,RASYM,mref,nref,FCAL,ff1)
C
      implicit none
      integer*4 masym,nasym,ia
      integer mref,nref,iref
      real*8 RDEN(masym),RASYM(masym),FCAL(2,mref),fr,fi,ff1
      real*8 RMIC(mref,masym),RMIS(mref,masym)
C
      DO 210 iref=1,nref
         fr=0.0
         fi=0.0
         DO 220 ia=1,nasym
            fr=fr+RDEN(ia)*RMIC(iref,ia)/RASYM(ia)
            fi=fi+RDEN(ia)*RMIS(iref,ia)/RASYM(ia)
  220    CONTINUE
         FCAL(1,iref)=fr*ff1
         FCAL(2,iref)=fi*ff1
  210 CONTINUE
C
      RETURN
      END
C
